'
' Test program for the EDM32.INC custom control editor.
' Shows most of the basic features in the editor control.
' Public Domain by Borje Hagsten, July 2001
'
' LOG:
' October 15, 2004: See EDM32.INC for more info.
' April   15, 2003: Cleaned up this sample code and now use COMDLG32.INC
'                   instead of own implementations of the Open/Save file
'                   dialog routines in it. Also did some changes to the
'                   include file. See EDM32.INC for more info.
'
' EDM32.INC updated and corrected to work with PBWin 7.04 - Oct 2004
' testedm.bas updated and corrected to work with PBWin 7.04 - Oct 2004
' (some asciiz changes in 7.01 affected old open/save file dialog code)
'
'
$Compile Exe
#Resource "EDM32.PBR"   'EDM32 resource file, with right-hand cursor
'--------------------------------------------------------------------
#Include "WIN32API.INC" 'Win API declares, etc.
#Include "COMDLG32.INC" 'Open/Save dlg declares, etc.
#Include "CommCtrl.inc"  ' Common control declares and equates, etc.
#Include "InitCtrl.inc"

#Include "EDM32.INC"    'EDM32 include file
'--------------------------------------------------------------------
%ID_NEW      = 110       'Control Id's
%ID_OPEN     = 111
%ID_SAVE     = 112
%ID_LBL1     = 130
%ID_LBL2     = 131
%ID_LBL3     = 132
%ID_LBL4     = 133
%ID_COMBO    = 140
%ID_EDIT     = 150
%ID_UNDO     = 160
%ID_REDO     = 161
%ID_CUT      = 162
%ID_COPY     = 163
%ID_PASTE    = 164
%ID_DELETE   = 165
%ID_SELALL   = 166
%ID_UCASE    = 170
%ID_LCASE    = 171
%ID_MCASE    = 172
%ID_TCASE    = 173
%ID_REM      = 180
%ID_NOREM    = 181
%ID_INDENT   = 182
%ID_OUTDENT  = 183
%ID_SORTASC  = 184
%ID_SORTDESC = 186
%ID_BMSET    = 190
%ID_BMSUBS   = 191
%ID_BMNEXT   = 193
%ID_BMPREV   = 194
%ID_BMCLEAR  = 195
%ID_SYNTAX   = 200
%ID_GRID     = 201
%ID_SNPRINT  = 202
%ID_DOCINFO  = 210
%IDM_Delim1  = 5051
'--------------------------------------------------------------------
%ID_STATUSBAR         = %WM_USER      + 1025&  ' statusbar
%ID_TOOLBAR           = %WM_USER      + 1024&  ' toolbar

'--------------------------------------------------------------------





Global ghCombo As Dword, ghEdit As Dword, ghMenuPopup As Dword, ghMenuPop4 As Dword

Global g_NewComCtl    As CurrencyX
Global g_hStatus      As Dword
Global g_hToolbar     As Dword


'--------------------------------------------------------------------
Declare CallBack Function DlgMainProc
Declare Function CheckSaveStatus(ByVal hDlg As Dword) As Long
Declare Sub OpenEdmFile(ByVal hDlg As Dword)
Declare Sub SaveEdmFile(ByVal hDlg As Dword)
Declare Sub ShowMenuEdit

Declare Function AttachACCELERATOR1(ByVal hDlg As Dword) As Dword
Declare Function AssignAccel(tAccel As ACCELAPI, ByVal wKey As Word, ByVal wCmd As Word, ByVal byFVirt As Byte) As Long


'
' Program Entrance
'--------------------------------------------------------------------


Function AttachACCELERATOR1(ByVal hDlg As Dword) As Dword

    Local hAccel   As Dword
    Local tAccel() As ACCELAPI
    Dim   tAccel(1 To 1) As ACCELAPI

    AssignAccel tAccel(1), %VK_F4, %IDCANCEL, %FVIRTKEY Or %FALT Or  %FNOINVERT

    AssignAccel tAccel(2), Asc("N"), %ID_NEW, %FVIRTKEY Or %FCONTROL Or  %FNOINVERT


    Accel Attach hDlg, tAccel() To hAccel
    Function = hAccel
End Function
'------------------------------------------------------------------------------

'------------------------------------------------------------------------------
Function AssignAccel(tAccel As ACCELAPI, ByVal wKey As Word, ByVal wCmd As _
    Word, ByVal byFVirt As Byte) As Long
    tAccel.fVirt = byFVirt
    tAccel.key   = wKey
    tAccel.cmd   = wCmd
End Function
'------------------------------------------------------------------------------


Function MakeAccelerators() As Dword
'------------------------------------------------------------------------------
  ' Create an Accelerator table for keyboard shortcuts
  '-----------------------------------------------------------------------------
  Dim c As Long, ac(9) As ACCELAPI  ' for keyboard accelator table values

  ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).KEY   = %VK_O : ac(c).cmd   = %ID_OPEN   : Incr c
  ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).KEY   = %VK_N : ac(c).cmd   = %ID_NEW    : Incr c
  ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).KEY   = %VK_S : ac(c).cmd   = %ID_SAVE   : Incr c
  ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).KEY   = %VK_Q : ac(c).cmd   = %IDCANCEL   : Incr c

  Function = CreateAcceleratorTable(ac(0), UBound(ac))
End Function



'==============================================================================
Function MakeToolBar (ByVal hWnd As Dword) As Dword
'------------------------------------------------------------------------------
  ' Setup and create the ToolBar
  '----------------------------------------------------------------------------
  Local c As Long, hToolBar As Dword
  Dim tbb(4) As TBBUTTON  'for 11 buttons, including separators

  ' Fill the TBBUTTON array with button information
  tbb(c).iBitmap   = %STD_FILENEW
  tbb(c).idCommand = %ID_NEW
  tbb(c).fsState   = %TBSTATE_ENABLED
  tbb(c).fsStyle   = %TBSTYLE_BUTTON
  Incr c

  tbb(c).iBitmap   = %STD_FILEOPEN
  tbb(c).idCommand = %ID_OPEN
  tbb(c).fsState   = %TBSTATE_ENABLED
  If g_NewComCtl >= 4.7 Then
     tbb(c).fsStyle = %TBSTYLE_DROPDOWN
  Else
     tbb(c).fsStyle = %TBSTYLE_BUTTON
  End If
  Incr c

  tbb(c).iBitmap   = %STD_FILESAVE
  tbb(c).idCommand = %ID_SAVE
  tbb(c).fsState   = %TBSTATE_ENABLED
  tbb(c).fsStyle   = %TBSTYLE_BUTTON
  Incr c


  tbb(c).iBitmap   = 0
  tbb(c).idCommand = 701
  tbb(c).fsState   = %TBSTATE_ENABLED
  tbb(c).fsStyle   = %TBSTYLE_SEP
  Incr c

 ' tbb(c).iBitmap   = %STD_PROPERTIES
 ' tbb(c).idCommand = %IDM_RUN
 ' tbb(c).fsState   = %TBSTATE_ENABLED
 'tbb(c).fsStyle   = %TBSTYLE_BUTTON
 ' Incr c


 '   tbb(c).iBitmap   = 0
 ' tbb(c).idCommand = 701
 ' tbb(c).fsState   = %TBSTATE_ENABLED
 ' tbb(c).fsStyle   = %TBSTYLE_SEP
 ' Incr c


  'tbb(c).iBitmap   = %STD_PRINT
  'tbb(c).idCommand = %IDM_PRINT
  'tbb(c).fsState   = %TBSTATE_ENABLED
  'tbb(c).fsStyle   = %TBSTYLE_BUTTON
  'Incr c

  'tbb(c).iBitmap   = 0
  'tbb(c).idCommand = 702
  'tbb(c).fsState   = %TBSTATE_ENABLED
  'tbb(c).fsStyle   = %TBSTYLE_SEP
  'Incr c

  'tbb(c).iBitmap   = %STD_CUT
  'tbb(c).idCommand = %IDM_CUT
  'tbb(c).fsState   = %TBSTATE_ENABLED
  'tbb(c).fsStyle   = %TBSTYLE_BUTTON
  'Incr c

  'tbb(c).iBitmap   = %STD_COPY
  'tbb(c).idCommand = %IDM_COPY
  'tbb(c).fsState   = %TBSTATE_ENABLED
  'tbb(c).fsStyle   = %TBSTYLE_BUTTON
  'Incr c

 ' tbb(c).iBitmap   = %STD_PASTE
 ' tbb(c).idCommand = %IDM_PASTE
 ' tbb(c).fsState   = %TBSTATE_ENABLED
 ' tbb(c).fsStyle   = %TBSTYLE_BUTTON
 ' Incr c

 ' tbb(c).iBitmap   = 0
 ' tbb(c).idCommand = 703
 ' tbb(c).fsState   = %TBSTATE_ENABLED
 ' tbb(c).fsStyle   = %TBSTYLE_SEP
 ' Incr c

 ' tbb(c).iBitmap   = %STD_UNDO
 ' tbb(c).idCommand = %IDM_UNDO
 ' tbb(c).fsState   = %TBSTATE_ENABLED
 ' tbb(c).fsStyle   = %TBSTYLE_BUTTON
 ' Incr c

  hToolBar = CreateToolbarEx (hWnd, %WS_CHILD Or %WS_VISIBLE Or %TBSTYLE_TOOLTIPS, _
                              %ID_TOOLBAR, 12, %HINST_COMMCTRL, %IDB_STD_SMALL_COLOR, _
                              tbb(0), UBound(tbb) + 1, 0, 0, 16, 15, Len(TBBUTTON))

  If hToolBar Then
      SendMessage hToolBar, %TB_AUTOSIZE, 0, 0
      If g_NewComCtl >= 4.7 Then ' then we can use more modern features, like flat style, etc.
         SetWindowLong hToolBar, %GWL_STYLE, _
            GetWindowLong(hToolbar, %GWL_STYLE) Or %TBSTYLE_FLAT
         SendMessage hToolBar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS
      End If
  End If

  Function = hToolBar

End Function


Function PBMain () As Long
  Local hDlg As Dword
  Dialog New 0, "PowerBasic open source code editor, based on EDM32 -  Right-click for edit menu..",,, _
                 392, 236, %WS_OVERLAPPEDWINDOW To hDlg


  ghEdit = CreateEdm32edit(hDlg, %ID_EDIT,  -1, 18, 395, 216, _
                          %WS_CHILD Or %WS_VISIBLE Or %WS_TABSTOP Or _
                          %WS_VSCROLL Or %WS_HSCROLL, %WS_EX_CLIENTEDGE, 1)


  SendMessage ghEdit, %EDM_SETBMCOLOR, RGB(0,255,255), 0 'set new bookmark color (default is red)
  SendMessage ghEdit, %EDM_SETKBSHORTCUTS, %TRUE, 0      'tell control to use internal keyboard shortcuts

  Control Add ComboBox, hDlg, %ID_COMBO, ,          280, 4, 110, 200, %CBS_DROPDOWNLIST Or _
                                                                      %CBS_SORT Or %WS_VSCROLL
  Control Handle hDlg, %ID_COMBO To ghCombo         'store combo's handle in global variable
  edmGetSubs ghEdit, ghCombo, 0                     'initialize sub/function finder combo

  Local hMenu   As Dword
  Local hPopUp1 As Dword

  Menu New Bar To hMenu
  Menu New PopUp To hPopUp1
  Menu Add PopUp, hMenu, "File", hPopUp1, %MF_ENABLED
        Menu Add String, hPopUp1, "New"+ $Tab + "Ctrl+N", %ID_NEW, %MF_ENABLED
        Menu Add String, hPopUp1, "Open", %ID_OPEN, %MF_ENABLED
        Menu Add String, hPopUp1, "Save as", %ID_SAVE, %MF_ENABLED
        Menu Add String, hPopUp1, "-", %IDM_Delim1, %MF_ENABLED
        Menu Add String, hPopUp1, "Exit"+ $Tab + "Alt+F4", %IDCANCEL, %MF_ENABLED

  Menu Attach hMenu, hDlg
  AttachACCELERATOR1 hDlg

  Dialog Show Modal hDlg, Call DlgMainProc





End Function

'
' Dialog Callback procedure
'--------------------------------------------------------------------
CallBack Function DlgMainProc

Local zText       As Asciiz * %MAX_PATH

  Select Case CbMsg


    Case %WM_INITDIALOG
       Local lRes As Long, lRes2 As Long, lRes3 As Long, lRes4 As Long, rc As RECT
       Local f As String, nm As NMHDR Ptr
       '  Note - always use fixed-width fonts like Courier or Fixedsys, etc.
       Call edmSetFontEditor(ghEdit, "Courier New", 9, 0, 0, 0)
       Dialog DoEvents
             '------------------------------------------------------------------------
      ' some of CommCtrl.dll's controls, messages and styles were not included
      ' in standard Win95A release, so we need to see how to initiate the dll.
      '------------------------------------------------------------------------
      g_NewComCtl = InitComctl32 (%ICC_BAR_CLASSES)

      '------------------------------------------------------------------------
      ' Create the status bar
      g_hStatus = CreateStatusWindow (%WS_CHILD Or %WS_VISIBLE Or %SBS_SIZEGRIP, _
                                      "",CbHndl , %ID_STATUSBAR)

      'set up a couple of statusbar parts
      Dim prts(3) As Long
      prts(0) = 100
      prts(1) = 200
      prts(2) = 300
      prts(3) =  -1

      Sendmessage g_hStatus, %SB_SETPARTS, 4, VarPtr(prts(0))
      SendMessage g_hStatus, %SB_SETTEXT, 0, VarPtr(zText)

      g_hToolbar = MakeToolBar (CbHndl)


      '------------------------------------------------------------------------

     Case %EDM_SETINFO 'trap notification from editor control, and get/show info in labels

         zText= " Line: " + Str$(SendMessage(ghEdit, %EDM_GETCARETY, 0, 0) + 1)
         SendMessage g_hStatus, %SB_SETTEXT, 0, VarPtr(zText)


         zText=  " Col: " + Str$(SendMessage(ghEdit, %EDM_GETCARETX, 0, 0) + 1)
         SendMessage g_hStatus, %SB_SETTEXT, 1, VarPtr(zText)


         zText= " Len: " + Str$(SendMessage(ghEdit, %EDM_GETTEXTLEN, 0, 0))
         SendMessage g_hStatus, %SB_SETTEXT, 2, VarPtr(zText)

         zText= " Sel: " + Str$(SendMessage(ghEdit, %EDM_GETSELLENGTH, 0, 0))
         SendMessage g_hStatus, %SB_SETTEXT, 3, VarPtr(zText)

     Case %WM_COMMAND
        Select Case CbCtl ' handle all controls and response from right-click edit menu here
           Case %ID_NEW
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then
                 If Sendmessage(ghEdit, %EDM_GETTEXTLEN, 0, 0) Then            'is there any text?
                    If CheckSaveStatus(CbHndl) = %IDCANCEL Then Exit Function  'need to save?
                    Call SendMessage(ghEdit, %EDM_LOADFILE, 0, 1)              'clear control, lParam sets focus
                 Else
                    SetFocus ghEdit                                            'else simply return focus to editor
                 End If
              End If

           Case %ID_OPEN
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then OpenEdmFile CbHndl 'Show Open File dialog
           Case %ID_SAVE
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then SaveEdmFile CbHndl 'Show Save File dialog
           Case %IDCANCEL
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then
                 If CheckSaveStatus(CbHndl) <> %IDCANCEL  Then 'need to save before exiting?
                    Dialog End CbHndl                          'if not Cancel, we can close the program
                 End If
              End If

           Case %ID_COMBO                       'Sub/Function finder combo
              Select Case HiWrd(CbWParam)
                 Case %CBN_DROPDOWN             'Refresh list
                    edmGetSubs ghEdit, ghCombo, 0

                 Case %CBN_SELENDOK             'go to selected function/sub
                    SetFocus ghEdit             'close combo before going..
                    lRes = SendMessage(ghCombo, %CB_GETCURSEL, 0, 0)
                    lRes = SendMessage(ghCombo, %CB_GETITEMDATA, lRes, 0)
                    Call SendMessage(ghEdit, %EDM_GOTOLINE, lRes, 1)
              End Select

       'POPUP MENU COMMANDS
           Case %ID_UNDO
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then SendMessage ghEdit, %EDM_UNDO, 0, %TRUE
           Case %ID_REDO
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then SendMessage ghEdit, %EDM_REDO, 0, %TRUE

           Case %ID_CUT
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then SendMessage ghEdit, %WM_CUT, 0, 0
           Case %ID_COPY
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then SendMessage ghEdit, %EDM_COPY, 0, 0
           Case %ID_PASTE
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then SendMessage ghEdit, %EDM_PASTE, 0, 0
           Case %ID_DELETE
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then SendMessage ghEdit, %EDM_DELETE, 0, -1
           Case %ID_SELALL
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then SendMessage ghEdit, %EM_SETSEL, 0, -1

           Case %ID_UCASE
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then SendMessage ghEdit, %EDM_UCASE, 0, -1
           Case %ID_LCASE
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then SendMessage ghEdit, %EDM_LCASE, 0, -1
           Case %ID_MCASE
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then SendMessage ghEdit, %EDM_MCASE, 0, -1
           Case %ID_TCASE
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then SendMessage ghEdit, %EDM_TCASE, 0, -1

           Case %ID_REM
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then SendMessage ghEdit, %EDM_COMMENT, 0, 0
           Case %ID_NOREM
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then SendMessage ghEdit, %EDM_COMMENT, 0, 1
           Case %ID_INDENT
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then SendMessage ghEdit, %EDM_COMMENT, 0, 2
           Case %ID_OUTDENT
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then SendMessage ghEdit, %EDM_COMMENT, 0, 3
           Case %ID_SORTASC
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then SendMessage ghEdit, %EDM_SORTLINES, 1, 0
           Case %ID_SORTDESC
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then SendMessage ghEdit, %EDM_SORTLINES, 3, 0

           Case %ID_BMSET
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then SendMessage ghEdit, %EDM_SETBMARK, 0, 0
           Case %ID_BMSUBS
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then edmGetSubs ghEdit, 0, 0
           Case %ID_BMNEXT
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then SendMessage ghEdit, %EDM_NEXTBMARK, 0, 0
           Case %ID_BMPREV
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then SendMessage ghEdit, %EDM_PREVBMARK, 0, 0
           Case %ID_BMCLEAR
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then SendMessage ghEdit, %EDM_RESETBMARKSALL, 0, 0

           Case %ID_SYNTAX 'Toggle syntax coloring
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then
                 If SendMessage(ghEdit, %EDM_GETSYNTAXONOFF, 0, 0) Then
                    Call SendMessage(ghEdit, %EDM_SETSYNTAXONOFF, 0, 0)
                    Call CheckMenuItem(ghMenuPop4, %ID_SYNTAX, %MF_CHECKED)
                 Else
                    Call SendMessage(ghEdit, %EDM_SETSYNTAXONOFF, 1, 0)
                    Call CheckMenuItem(ghMenuPop4, %ID_SYNTAX, %MF_UNCHECKED)
                 End If
              End If

           Case %ID_SNPRINT 'Show/hide non-printable characters
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then
                 If SendMessage(ghEdit, %EDM_GETSHOWNONPRINT, 0, 0) Then
                    Call SendMessage(ghEdit, %EDM_SETSHOWNONPRINT, 0, 0)
                    Call CheckMenuItem(ghMenuPop4, %ID_SNPRINT, %MF_CHECKED)
                 Else
                    Call SendMessage(ghEdit, %EDM_SETSHOWNONPRINT, 1, 0)
                    Call CheckMenuItem(ghMenuPop4, %ID_SNPRINT, %MF_UNCHECKED)
                 End If
              End If

           Case %ID_GRID 'Toggle gridlines
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then
                 If SendMessage(ghEdit, %EDM_GETGRID, 0, 0) Then
                    Call SendMessage(ghEdit, %EDM_SETGRID, 0, 0)
                    Call CheckMenuItem(ghMenuPop4, %ID_GRID, %MF_CHECKED)
                 Else
                    Call SendMessage(ghEdit, %EDM_SETGRID, 1, 0)
                    Call CheckMenuItem(ghMenuPop4, %ID_GRID, %MF_UNCHECKED)
                 End If
              End If

           Case %ID_DOCINFO 'Show statistics
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then
                 f = edmGetFileName(ghEdit)
                 If Len(f) Then
                    f = Mid$(f, InStr(-1, f, "\") + 1)  'dialog will return full path and file name
                 Else
                    f = "Untitled.bas"
                 End If
                 lRes  = Sendmessage(ghEdit, %EDM_GETWORDCOUNT, 0, -1) 'word count in selected text
                 lRes2 = Sendmessage(ghEdit, %EDM_GETWORDCOUNT, 0, 0)  'word count in whole text
                 lRes3 = Sendmessage(ghEdit, %EDM_GETTEXTLEN, 0, 0)    'Text length
                 lRes4 = Sendmessage(ghEdit, %EDM_GETSELLENGTH, 0, 0)  'Selection length
                 MsgBox "File: " & f & $CrLf & $CrLf & _
                        "Length: " & Str$(lRes3) & " bytes." & $CrLf & _
                        "SelLen: " & Str$(lRes4) & " bytes." & $CrLf & $CrLf & _
                        "Word count, whole text: " & Str$(lRes2) & $CrLf & _
                        "Word count, selection:  " & Str$(lRes) & $CrLf & $CrLf & _
                        edmTxtGetFileSummary(ghEdit)
              End If

        End Select

     Case %WM_NCACTIVATE
        If CbWParam Then Call SetFocus(ghEdit)  '<- set focus to editor control

     Case %WM_NOTIFY
        nm = CbLParam                           '%NM_RCLICK = %NM_FIRST-5
        If @nm.hWndFrom = ghEdit And @nm.code = %NM_FIRST-5 Then ShowMenuEdit


     Case %WM_SIZE 'resize edit control if parent is resized
        If CbWParam <> %SIZE_MINIMIZED Then
           GetWindowRect ghEdit, rc            ' get control's coordinates on screen
           MapWindowPoints 0, CbHndl, rc, 2    ' map result to dialog - we need top pos
          ' SetWindowPos ghEdit, 0, 0, 0, LOWRD(CBLPARAM) + 4, _  ' width
          '              HIWRD(CBLPARAM) - rc.nTop + 2, _         ' height
          '              %SWP_NOMOVE OR %SWP_NOZORDER

           SetWindowPos ghEdit, 0, 0, 0, LoWrd(CbLParam) + 2, _  ' width
                        HiWrd(CbLParam) - rc.nTop - 20, _         ' height
                        %SWP_NOMOVE Or %SWP_NOZORDER


           SendMessage g_hStatus, CbMsg, CbWParam, CbLParam
         '   Control ReDraw CbHndl, ghCombo

        End If

     Case %WM_SYSCOMMAND
        If CbWParam = %SC_CLOSE Then
           If CheckSaveStatus(CbHndl) = %IDCANCEL  Then 'need to save before exiting?
              Function = 1: Exit Function               'if cancel, return 1 to break action
           End If
        End If

  End Select
End Function

'
' Build and show popup menu on right-click
'
Sub ShowMenuEdit
  Local editFlag  As Long, readFlag  As Long, selFlag   As Long, _
        txtFlag   As Long, sortFlag  As Long, _
        hMenuPop1 As Dword, hMenuPop2 As Dword, hMenuPop3 As Dword, _
        txt       As String, pt As POINTAPI

  GetCursorPos pt                                                   'GET CURSOR'S POSITION ON SCREEN

  editFlag = %MF_GRAYED : readFlag = %MF_GRAYED : selFlag = %MF_GRAYED 'pre-set these as grayed
  txtFlag = %MF_GRAYED  : sortFlag = %MF_GRAYED

  If SendMessage(ghEdit, %EDM_GETTEXTLEN, 0, 0) Then                'if text exist
     txtFlag = %MF_ENABLED                                          'set txtFlag
  End If

  If SendMessage(ghEdit, %EDM_GETSELLENGTH, 0, 0) Then              'if selection exist
     selFlag = %MF_ENABLED                                          'set selFlag
  End If

  If SendMessage(ghEdit, %EDM_GETREADONLY, 0, 0) = 0 Then           'and editing is possible
     readFlag = %MF_ENABLED                                         'editing allowed, set readFlag
     If selFlag = %MF_ENABLED Then editFlag = %MF_ENABLED           'all ok, so change to enabled
  End If

  If SendMessage(ghEdit, %EDM_GETLINECOUNT, 0, 0) Then              'See if text exist
     If SendMessage(ghEdit, %EDM_GETSELSTARTY, 0, 0) <> _           'if >1 lines are selected
        SendMessage(ghEdit, %EDM_GETSELENDY, 0, 0) Then

        sortFlag = %MF_ENABLED                                      'set sortFlag
     End If
  End If


  Menu New PopUp To ghMenuPopup                                     'BUILD MENU

  txt = edmUndoGetDescription(ghEdit, -1) + Chr$(9) + "Ctrl + Z"    'UNDO
  If SendMessage(ghEdit, %EDM_CANUNDO, 0, 0) Then
     Menu Add String, ghMenuPopup, txt, %ID_UNDO, %MF_ENABLED
  Else
     Menu Add String, ghMenuPopup, txt, %ID_UNDO, %MF_GRAYED
  End If

  txt = edmUndoGetDescription(ghEdit, 0) + Chr$(9) + "Ctrl + Y"     'REDO
  If SendMessage(ghEdit, %EDM_CANREDO, 0, 0) Then
     Menu Add String, ghMenuPopup, txt, %ID_REDO, %MF_ENABLED
  Else
     Menu Add String, ghMenuPopup, txt, %ID_REDO, %MF_GRAYED
  End If

  Menu Add String, ghMenuPopup, "-",           0, 0                 'SEPARATOR

  txt = "Cut" + Chr$(9) + "Ctrl + X"
  Menu Add String, ghMenuPopup, txt, %ID_CUT, editFlag              'CUT

  If selFlag = %MF_ENABLED Then                                     'COPY
     txt = "Copy selection" + Chr$(9) + "Ctrl + C"
  Else
     txt = "Copy all" + Chr$(9) + "Ctrl + C"
  End If
  Menu Add String, ghMenuPopup, txt, %ID_COPY, txtFlag

  If IsClipboardFormatAvailable(%CF_TEXT) And readFlag = %MF_ENABLED Then 'PASTE
     Menu Add String, ghMenuPopup, "Paste" + Chr$(9) + "Ctrl + V", %ID_PASTE, %MF_ENABLED
  Else
     Menu Add String, ghMenuPopup, "Paste" + Chr$(9) + "Ctrl + V", %ID_PASTE, %MF_GRAYED
  End If

  Menu Add String, ghMenuPopup, "Delete", %ID_DELETE, editFlag      'DELETE
  Menu Add String, ghMenuPopup, "-",           0, 0                 'SEPARATOR
  Menu Add String, ghMenuPopup, "Select All" + Chr$(9) + _
                                "Ctrl + A", %ID_SELALL, txtFlag     'SELECT ALL
  Menu Add String, ghMenuPopup, "-",           0, 0                 'SEPARATOR

  Menu New PopUp To hMenuPop1 '<- nested menu for line procedures
  Menu Add PopUp, ghMenuPopup, " Line(s)..." , hMenuPop1,  readFlag
     Menu Add String, hMenuPop1, "Rem out", %ID_REM, %MF_ENABLED
     Menu Add String, hMenuPop1, "Remove Rem out", %ID_NOREM, %MF_ENABLED
     Menu Add String, hMenuPop1, "-",           0, 0
     Menu Add String, hMenuPop1, "Indent" + Chr$(9) + "TAB", %ID_INDENT, %MF_ENABLED
     Menu Add String, hMenuPop1, "Outdent" + Chr$(9) + "Shift + TAB", %ID_OUTDENT, %MF_ENABLED
     Menu Add String, hMenuPop1, "-",           0, 0
     Menu Add String, hMenuPop1, "Sort ascending", %ID_SORTASC, sortFlag
     Menu Add String, hMenuPop1, "Sort descending", %ID_SORTDESC, sortFlag

  Menu New PopUp To hMenuPop2 '<- nested menu for text case procedures
  Menu Add PopUp, ghMenuPopup, " Shift Case to..." , hMenuPop2,  editFlag
     Menu Add String, hMenuPop2, "UPPER CASE" + Chr$(9) + "Ctrl + U", %ID_UCASE, %MF_ENABLED
     Menu Add String, hMenuPop2, "lower case" + Chr$(9) + "Ctrl + L", %ID_LCASE, %MF_ENABLED
     Menu Add String, hMenuPop2, "Mixed Case" + Chr$(9) + "Ctrl + M", %ID_MCASE, %MF_ENABLED
     Menu Add String, hMenuPop2, "tOGGLED cASE" + Chr$(9) + "Ctrl + T", %ID_TCASE, %MF_ENABLED

  Menu New PopUp To hMenuPop3 '<- nested menu for bookmark procedures
  Menu Add PopUp, ghMenuPopup, " BookMark..." , hMenuPop3,  %MF_ENABLED
     Menu Add String, hMenuPop3, "Toggle on/off" + Chr$(9) + "Ctrl + F2", %ID_BMSET, %MF_ENABLED
     Menu Add String, hMenuPop3, "All Subs/Functions", %ID_BMSUBS, %MF_ENABLED
     Menu Add String, hMenuPop3, "-",           0, 0
     Menu Add String, hMenuPop3, "Goto Next" + Chr$(9) + "F2", %ID_BMNEXT, %MF_ENABLED
     Menu Add String, hMenuPop3, "Goto Previous" + Chr$(9) + "Shift + F2", %ID_BMPREV, %MF_ENABLED
     Menu Add String, hMenuPop3, "-",           0, 0
     Menu Add String, hMenuPop3, "Clear all", %ID_BMCLEAR, %MF_ENABLED

  Menu New PopUp To ghMenuPop4 '<- nested menu for settings
  Menu Add PopUp, ghMenuPopup, " Settings..." , ghMenuPop4,  %MF_ENABLED
     Menu Add String, ghMenuPop4, "Show syntax coloring" + Chr$(9) + "Ctrl + H", %ID_SYNTAX, %MF_ENABLED
     Menu Add String, ghMenuPop4, "Show Gridlines" + Chr$(9) + "Ctrl + G", %ID_GRID, %MF_ENABLED
     Menu Add String, ghMenuPop4, "Show non-printable characters", %ID_SNPRINT, %MF_ENABLED

  Menu Add String, ghMenuPopup, "-", 0, 0                                   'SEPARATOR
  Menu Add String, ghMenuPopup, "Document info..", %ID_DOCINFO, %MF_ENABLED 'DOCUMENT INFO

  If SendMessage(ghEdit, %EDM_GETSYNTAXONOFF, 0, 0) Then
     Call CheckMenuItem(ghMenuPop4, %ID_SYNTAX, %MF_CHECKED)
  Else
     Call CheckMenuItem(ghMenuPop4, %ID_SYNTAX, %MF_UNCHECKED)
  End If

  If SendMessage(ghEdit, %EDM_GETSHOWNONPRINT, 0, 0) Then
     Call CheckMenuItem(ghMenuPop4, %ID_SNPRINT, %MF_CHECKED)
  Else
     Call CheckMenuItem(ghMenuPop4, %ID_SNPRINT, %MF_UNCHECKED)
  End If

  If SendMessage(ghEdit, %EDM_GETGRID, 0, 0) Then
     Call CheckMenuItem(ghMenuPop4, %ID_GRID, %MF_CHECKED)
  Else
     Call CheckMenuItem(ghMenuPop4, %ID_GRID, %MF_UNCHECKED)
  End If

  TrackPopupMenu ghMenuPopup, 0, pt.x, pt.y, 0, ghEdit, ByVal %NULL

End Sub

'
' Check if editor's contents needs saving
'
Function CheckSaveStatus (ByVal hDlg As Dword) As Long
  Local lRes As Long, f As String, Buffer As String

  If SendMessage(ghEdit, %EDM_GETCHANGED, 0, 0) And _
     Sendmessage(ghEdit, %EDM_GETTEXTLEN, 0, 0) Then     'if text has changed and have length

     f      = "Save?" & Chr$(0)                          'enable user to save before opening new
     Buffer = "Save changes to current text?" & Chr$(0)
     lRes = MessageBox(hDlg, ByVal StrPtr(Buffer), ByVal StrPtr(f), _
                       %MB_YESNOCANCEL Or %MB_ICONQUESTION)
     If lRes = %IDYES Then SaveEdmFile hDlg              'if yes, show Save dialog
     Function = lRes
  End If
End Function

'
' Show Open File dialog
'
Sub OpenEdmFile (ByVal hDlg As Dword)
  Local Style As Dword, Buffer As String, f As String, Path As String

  If CheckSaveStatus(hDlg) = %IDCANCEL Then Exit Sub 'need to save before loading new text?

  f      = "*.BAS;*.INC"
  Path   = CurDir$
  Buffer =          "PB Files (*.BAS, *.INC)|*.BAS;*.INC|"
  Buffer = Buffer & "Resource Files (*.RC)|*.RC|"
  Buffer = Buffer & "Internet Files (*.HTML, *.HTM)|*.html;*.htm|"
  Buffer = Buffer & "Text Files (*.TXT)|*.TXT|"
  Buffer = Buffer & "All Files (*.*)|*.*"
  Style  = %OFN_EXPLORER Or %OFN_FILEMUSTEXIST

  If OpenFileDialog(hDlg, "", f, Path, Buffer, "BAS" , Style) Then
      Sleep 1                                                 'take a breath..
      If Len(f) Then                                          'if we have a file name
         Call SendMessage(ghEdit, %EDM_LOADFILE, ByVal StrPtr(f), 0) 'load the file
         If (Style And %OFN_READONLY) Then                    'if ReadOnly was selected
            Call SendMessage(ghEdit, %EDM_SETREADONLY, 1, 0)  'set ReadOnly mode
         Else
            Call SendMessage(ghEdit, %EDM_SETREADONLY, 0, 0)  'reset ReadOnly mode
         End If
         Call edmGetSubs(ghEdit, ghCombo, 0)                  'populate sub/function finder combo
      End If
  End If

End Sub

'
' Save edit control's contents to file
'
Sub SaveEdmFile (ByVal hDlg As Dword)
  Local hFile As Dword, Style As Dword, _
        Buffer As String, Path As String, f As String, fType As String

  Style = %OFN_EXPLORER Or %OFN_FILEMUSTEXIST Or _
          %OFN_HIDEREADONLY Or %OFN_OVERWRITEPROMPT
  Buffer   =          "PB Code Files (*.BAS)|*.BAS|"
  Buffer   = Buffer & "PB Include Files (*.INC)|*.INC|"
  Buffer   = Buffer & "Resource Files (*.RC)|*.RC|"
  Buffer   = Buffer & "Text Files (*.TXT)|*.TXT|"
  Buffer   = Buffer & "All Files (*.*)|*.*"

  f = edmGetFileName(ghEdit)

  If Len(f) = 0 Then
     Path  = CurDir$
     f     = "Untitled.bas"
     fType = "BAS"
  Else
     Local Pos As Long
     Pos = InStr(-1, f, "\")
     If Pos Then
        Path = Left$(f, Pos)
        f    = Mid$(f, Pos + 1)  'dialog will return full path and file name
        If InStr(-1, f, ".") Then
           fType = edmUCASER(Mid$(f, InStr(-1, f, ".") + 1 ))
        End If
     End If
  End If

  'Show Save dialog. If user selects Cancel in Save dialog, exit.
  If IsFalse(SaveFileDialog(hDlg, "", f, Path, Buffer, fType, Style)) Then Exit Sub

  Sleep 1 'take a breath..
  Buffer = edmTxtGetSelText(ghEdit, 0)                    'edmTxtGetSelText returns all text if last param is 0

  hFile = FreeFile                                        'get free file handle
  Open f For Binary As hFile Len = 8192                   'open file for binary write
     If Err Then GoTo SaveFileError                       'always consider errors on File I/O
     Put$ hFile, Buffer                                   'write Buffer to disk
     SetEof hFile                                         'truncate file to proper length
  Close hFile                                             'close file handle

  SendMessage ghEdit, %EDM_SETCHANGED, 0, 0               'reset changed flag
Exit Sub

SaveFileError:                                            'Handle errors
  f      = "Error message!" & Chr$(0)
  Buffer = "Error #" + Format$(Err) + " occurred while trying to save the file."
  Call MessageBox(hDlg, ByVal StrPtr(Buffer), ByVal StrPtr(f), %MB_OK Or %MB_ICONEXCLAMATION)
  ErrClear : Reset
  Exit Sub
End Sub
